#! /bin/bash
inst=$(pwd)
cd ../../..
if
	kelp=$(ls -ld [Kk]elp-src* | grep "^d"| tail -1 | awk '{print $NF}')
	[ ! -d ${kelp:=Kelp-src} ]
then
	echo "No Kelp-src* directory; exiting"
	exit 1
fi
find $kelp -type d -name classes -exec rm -rf {} \;
find $kelp -type d -name output -exec rm -rf {} \;
version=$(echo $kelp | sed "s/[Kk]elp-src//")
rm -rf  kelp-$version 
rm -rf   $inst/../kelp-$version 
rm -rf   $inst/../Kelp
mkdir kelp-$version
cp -r $kelp/* kelp-$version

mv kelp-$version $inst/../kelp-$version
cd $inst/..
RPM=/usr/src/redhat
rm $RPM/SPECS/kelp-$version.spec
cp  kelp-$version/install/SPECS/kelp.spec $RPM/SPECS/kelp-$version.spec
cp  kelp-$version/modules/AddinConfigure/dist/jbuilder/lib/Enhydra.library.in kelp-$version
find  kelp-$version/install -name configure -exec chmod +x {} \;
tar -czvf $RPM/SOURCES/kelp-$version.tar.gz  kelp-$version
if
	[ $? -ne 0 ]
then
	echo "tar archive could not be created; exiting"
        exit 2
fi

while
	read l
do
	if
		echo $l | egrep '[ 	]*#
^[ 	]*$
^[ 	]*-[ 	]*$' >/dev/null
	then
		continue
	fi
	l=$(echo $l | sed 's/=/ /')
	set - $l
	eval $1=$2
done <$inst/kelp.properties
set -x
if
	[ x${jdk_home:=$JDK_HOME} = x ]
then
	echo "jdk_home must be set in kelp.properties or"
	echo "environmnent varibale JDK_HOME must be set; exiting" 
	exit 3
fi
JDK_HOME=$jdk_home
export JDK_HOME
if [ -f ~/.rpmmacros ]
then
	mv  ~/.rpmmacros  ~/.rpmmacros.save
fi
echo "%debug_package %{nil}" > ~/.rpmmacros
jbuilder6=${jbuilder6_dir:=-}
jbuilder7=${jbuilder7_dir:=-}
jbuilder8=${jbuilder8_dir:=-}
netbeans=${netbeans_dir:=-}
netbeans34=${netbeans34_dir:=-}
eclipse=${eclipse_dir:=-}
eclipse21=${eclipse21_dir:=-}
jdeveloper=${jdeveloper_dir:=-}
{
	echo $enhydra_dir
	echo $jbuilder6_dir
	echo $jbuilder7_dir
	echo $jbuilder8_dir
	echo $netbeans_dir
	echo $netbeans34_dir
	echo $eclipse_dir
	echo $eclipse21_dir
	echo $jdeveloper_dir
} | rpmbuild -ba $RPM/SPECS/kelp-$version.spec
rm -f  ~/.rpmmacros
if [ -f ~/.rpmmacros.save ]
then
	mv  ~/.rpmmacros.save  ~/.rpmmacros
fi
if
	[ $? -ne 0 ]
then
	echo "rpm archives could not be created; exiting"
        exit 3
fi

mkdir -p Kelp/Kelp-install/Linux/RPM
mkdir -p Kelp/Kelp-install/Linux/TAR.GZ
mkdir -p Kelp/Kelp-src/Linux/

cp  $RPM/SRPMS/kelp-$version-1.src.rpm  Kelp/Kelp-src/Linux/
cp  $RPM/SOURCES/kelp-$version.tar.gz  Kelp/Kelp-src/Linux/kelp-$version.src.tar.gz

for name in \
	jbuilder6_dir:jbuilder:JBuilder6 \
	jbuilder7_dir:jbuilder7:JBuilder7 \
	jbuilder8_dir:jbuilder8:JBuilder8 \
	netbeans_dir:netbeans:NetBeans \
	netbeans34_dir:netbeans34:NetBeans34 \
	eclipse_dir:eclipse:eclipse \
	eclipse21_dir:eclipse21:eclipse21 \
	jdeveloper_dir:jdeveloper:jdeveloper
do
	name=$(echo $name | sed 's/:/ /g')
	set - $name
	dir=$1
	eval dir='$'$dir
	if
		[ $dir != '-' ]
	then
		file=$2
		Cfile=$3
		rm -rf tmp
		rpm2cpio $RPM/RPMS/i386/kelp-${file}-${version}-1.i386.rpm | cpio -id 
		mv tmp/kelp-$version/$Cfile/install.sh tmp
		chmod +x tmp/install.sh
		cd tmp
		tar -czvf ../Kelp/Kelp-install/Linux/TAR.GZ/kelp-${file}-${version}.tar.gz  *
		cd ..
		cp  $RPM/RPMS/i386/kelp-${file}-${version}-1.i386.rpm  Kelp/Kelp-install/Linux/RPM
	fi
done
rm -rf tmp kelp-$version
