;------------------------------------------------------------------------------
; Enhydra 5.1 installation script
;	All output message will be written to file ..\..\..\..\netbeans.log
;------------------------------------------------------------------------------

!define VERSION "5.1" ;Define your own software name here
!define MUI_PRODUCT "Kelp ${VERSION} for NetBeans" ;Define your own software name here
!define MUI_VERSION "${VERSION}" ;Define your own software version here

!include "${NSISDIR}\Contrib\Modern UI\System.nsh"
;------------------------------------------------------------------------------
;Configuration
;------------------------------------------------------------------------------
  !define MUI_WELCOMEPAGE
  !define MUI_LICENSEPAGE
  !define MUI_DIRECTORYPAGE
  
  !define MUI_ABORTWARNING

  !define MUI_CUSTOMPAGECOMMANDS
  
  !define MUI_UNINSTALLER
  !define MUI_UNCONFIRMPAGE

  !define TEMP1 $R0
  !define TEMP2 $R1
    
# Language
  !insertmacro MUI_LANGUAGE "English"

# General
	OutFile "..\..\..\..\distribution\kelp-netbeans-${VERSION}.setup.exe"	; The file to write

# Install Options pages
# LANG_ENGLISH
# Header
    LangString TEXT_IO_TITLE ${LANG_ENGLISH} "Please select the appropriate directories"
    LangString TEXT_IO_SUBTITLE ${LANG_ENGLISH} "Click button on right side to set the appropriate directories :"
# Window titles
    LangString TEXT_IO_PAGESUBTITLE_A ${LANG_ENGLISH} "Select Enhydra directory :"
    LangString TEXT_IO_PAGECUSTOM_A ${LANG_ENGLISH} "${MUI_PRODUCT}"

# Page order 
	!insertmacro MUI_PAGECOMMAND_WELCOME
	!insertmacro MUI_PAGECOMMAND_LICENSE
  Page custom SetCustomPage "$(TEXT_IO_PAGETITLE_A)"
  !insertmacro MUI_PAGECOMMAND_DIRECTORY
  !insertmacro MUI_PAGECOMMAND_INSTFILES
  
# License page
  LicenseData /LANG=${LANG_ENGLISH} "${NSISDIR}\Contrib\License\LicenseEnglish.txt"

# Component-selection page
    ;Titles
    LangString TITLE_SecCopyUI ${LANG_ENGLISH} "Kelp"

# Descriptions
    LangString DESC_SecCopyUI ${LANG_ENGLISH} "Install Kelp ${VERSION} to the application folder."

# Folder-selection page
  InstallDir "C:\"
  
# Things that need to be extracted on startup (keep these lines before any File command!)
# Only useful for BZIP2 compression
# Use ReserveFile for your own Install Options ini files too!
  !insertmacro MUI_RESERVEFILE_INSTALLOPTIONS
  ReserveFile "netbeans.ini"
;------------------------------------------------------------------------------
;Modern UI System
;------------------------------------------------------------------------------
!insertmacro MUI_SYSTEM
;------------------------------------------------------------------------------
;Installer Sections
;------------------------------------------------------------------------------
Section $(TITLE_SecCopyUI) SecCopyUI

  ; Set output path to the installation directory.
  StrCpy $1 $INSTDIR
  StrCpy $INSTDIR "$INSTDIR\Kelp5"
  StrCpy $OUTDIR "$INSTDIR\Kelp5"
  SetOutPath $INSTDIR

  File /r "..\..\NetBeans\*.*"
	  
  !insertmacro MUI_INSTALLOPTIONS_READ $2 "netbeans.ini" "Field 2" "State" ;Enhydra Directory

  ClearErrors
  ExecWait '"$INSTDIR\configure.bat" "$1" "$2"' $0	; start configuring Kelp
  StrCmp $0 "0" success

	DetailPrint "Kelp ${VERSION} failed (output: $0)"
	Call Cleanup
	Goto end

	success:
	DetailPrint "Kelp ${VERSION} succeded (output: $0)"

  ; Write the installation path into the registry
  WriteRegStr HKLM SOFTWARE\Kelp${VERSION}_for_NetBeans "Install_Dir" "$INSTDIR"

  ; Write the uninstall keys for Windows
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Kelp${VERSION}_for_NetBeans" "DisplayName" "Kelp ${VERSION} (remove only)"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Kelp${VERSION}_for_NetBeans" "UninstallString" '"$INSTDIR\uninstall.exe"'
  WriteUninstaller "uninstall.exe"

	; Create Start Menu Shortcuts
  CreateDirectory "$SMPROGRAMS\Kelp${VERSION} for NetBeans"
  CreateShortCut "$SMPROGRAMS\Kelp${VERSION} for NetBeans\Uninstall.lnk" "$INSTDIR\uninstall.exe" "" "$INSTDIR\uninstall.exe" 0
	
	end:
SectionEnd
;------------------------------------------------------------------------------
;Installer Functions
;------------------------------------------------------------------------------
Function .onInit

# start splash screen
# the plugins dir is automatically deleted when the installer exits
		InitPluginsDir
		File /oname=$PLUGINSDIR\splash.bmp "${NSISDIR}\Modern UI\KelpForNetBeans.bmp"
#optional
#File /oname=$PLUGINSDIR\splash.wav "C:\myprog\sound.wav"
		advsplash::show 1000 600 400 -1 $PLUGINSDIR\splash
		Pop $0 ; $0 has '1' if the user closed the splash screen early,
		                ; '0' if everything closed normal, and '-1' if some error occured.
# end splash screen

  ;Extract Install Options INI Files
  !insertmacro MUI_INSTALLOPTIONS_EXTRACT "netbeans.ini"

FunctionEnd
;---------------------------------------------------------------------------------
; Call when installation succeed
;---------------------------------------------------------------------------------
Function .onInstSuccess
FunctionEnd
;------------------------------------------------------------------------------
;Descriptions
;------------------------------------------------------------------------------
!insertmacro MUI_FUNCTIONS_DESCRIPTION_BEGIN
!insertmacro MUI_DESCRIPTION_TEXT ${SecCopyUI} $(DESC_SecCopyUI)
!insertmacro MUI_FUNCTIONS_DESCRIPTION_END
;------------------------------------------------------------------------------
;Uninstaller Section
;------------------------------------------------------------------------------
Section "Uninstall"
 
  ; remove registry keys
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Kelp${VERSION}_for_NetBeans"
  DeleteRegKey HKLM SOFTWARE\Kelp${VERSION}_for_NetBeans

  ; MUST REMOVE UNINSTALLER, too
  Delete $INSTDIR\uninstall.exe

  ; remove shortcuts, if any.
  Delete "$SMPROGRAMS\Kelp${VERSION} for NetBeans\*.*"

  ; remove directories used.
  RMDir "$SMPROGRAMS\Kelp${VERSION} for NetBeans"
  RMDir /r "$INSTDIR"
  
SectionEnd
;------------------------------------------------------------------------------
;Uninstaller Functions
;------------------------------------------------------------------------------
Function un.onInit

  ;Get language from registry
  ReadRegStr $LANGUAGE HKCU "Software\${MUI_PRODUCT}" "Installer Language"

FunctionEnd
;------------------------------------------------------------------------------
; Page to choose Enhydra install directory
;------------------------------------------------------------------------------
Function SetCustomPage

  !insertmacro MUI_INSTALLOPTIONS_WRITE "netbeans.ini" "Settings" "Title" "$(TEXT_IO_PAGECUSTOM_A)"

	start:

  !insertmacro MUI_HEADER_TEXT "$(TEXT_IO_TITLE)" "$(TEXT_IO_SUBTITLE)"
  !insertmacro MUI_INSTALLOPTIONS_DISPLAY "netbeans.ini"

   StrCmp $R0 "cancel" end
   StrCmp $R0 "back" end

  !insertmacro MUI_INSTALLOPTIONS_READ ${TEMP1} "netbeans.ini" "Field 2" "State" ;Enhydra Directory

	IfFileExists ${TEMP1}\lib\enhydra.jar end	; check if Enhydra exist
	MessageBox MB_OK "File enhydra.jar does not exist in directory ${TEMP1}\lib"
	Goto start

	end:
FunctionEnd
;------------------------------------------------------------------------------
; Call on installation failed
;------------------------------------------------------------------------------
Function .onInstFailed
	Call Cleanup
FunctionEnd
;------------------------------------------------------------------------------
; Call when installation failed 
;------------------------------------------------------------------------------
Function Cleanup
  ; remove registry keys
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Kelp${VERSION}_for_NetBeans"
  DeleteRegKey HKLM SOFTWARE\Kelp${VERSION}_for_NetBeans

  ; MUST REMOVE UNINSTALLER, too
  Delete $INSTDIR\uninstall.exe

  ; remove shortcuts, if any.
  Delete "$SMPROGRAMS\Kelp${VERSION} for NetBeans\*.*"

  ; remove directories used.
  RMDir "$SMPROGRAMS\Kelp${VERSION} for NetBeans"
  RMDir /r "$INSTDIR"
  
FunctionEnd
