#! /bin/bash
name=kelp
version=5.1
	echo -e "\n\n ${name}-JBuilder7-${version} installation script\n\n"
	default_jdkdir=/usr/java/j2sdk1.4.0_01
	JDK_HOME=${JDK_HOME:=$JAVA_HOME}
        while
                err=0
                if
                        [ X$JDK_HOME = X ]
                then
                        text="Warning: JDK_HOME is not defined."
                        err=1
                elif
                        [ ! -d $JDK_HOME ]
                then
                        text="Warning: No such directory: $JDK_HOME."
                        err=1
                elif
                        [ ! -r $JDK_HOME/bin/javac ]
                then
                        text="Warning: Not valid directory (no javac file): $JDK_HOME."
                        err=1
                fi
                [ $err -gt 0 ]
        do
                echo $text
                echo -e "\n\nPlease enter path to your "\
                        "Java Development Kit - JDK directory [$default_jdkdir] \c"
                read JDK_HOME 
                JDK_HOME=${JDK_HOME:=$default_jdkdir}
        done
        export JDK_HOME
	PATH=$JDK_HOME/bin:$PATH
	export PATH
        tools=$(find $JDK_HOME -name tools.jar -print)
        if
                echo $CLASSPATH | grep -v $tools
        then
                CLASSPATH=$CLASSPATH:$tools
                export CLASSPATH
        fi
	
	default_enhdir=/usr/local/enhydra5.1
        while
                echo -e "\n\nPlease enter path to your "\
                        "Enhydra root directory [$default_enhdir] \c"
                read enhdir 
                enhdir=${enhdir:=$default_enhdir}
                [ ! -d $enhdir ]
        do
                echo "Warning: No such directory: $enhdir"
        done
	default_jbdir7=/opt/JBuilder7
        while
                echo -e "\n\nPlease enter path to your "\
                        "JBuilder7 root directory [$default_jbdir7] \c"
                read jbdir7 
                jbdir7=${jbdir7:=$default_jbdir7}
                [ ! -d $jbdir7 ]
        do
                echo "Warning: No such directory: $jbdir7"
        done
	major_version=$(echo ${version}| cut -f1 -d'.')
	kelpdir=${jbdir7}/Kelp$major_version
	if
		[ ! -d ${kelpdir} ]
	then
		mkdir ${kelpdir}
	else
		echo "Kelp has already been installed, removing the contents of $kelpdir"
		rm -rf  ${kelpdir}/*
		if 
			[ -f  ${jbdir7}/bin/jbuilder.config.save ]
		then
			mv -f ${jbdir7}/bin/jbuilder.config.save  ${jbdir7}/bin/jbuilder.config
		fi
	fi
	cd $(dirname $0)
	mv ${name}-${version}/JBuilder7/* ${kelpdir}
	cd ${kelpdir}
	if
		./configure -j $jbdir7 $enhdir $JDK_HOME
	then
		echo -e "\n\nThe installation has been successful"
	else
		echo -e "\n\nThe installation failed"
		exit 1
	fi
