/*
 * Enhydra Java Application Server Project
 *
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific terms governing rights and limitations
 * under the License.
 *
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 *
 * Contributor(s):
 * Paul Mahar
 *
 */
package org.enhydra.kelp.common.deployer;

// Kelp imports
import org.enhydra.kelp.common.event.WriteListener;
import org.enhydra.kelp.common.node.OtterProject;

// ToolBox imports
import org.enhydra.tool.common.DataValidationException;
import org.enhydra.tool.common.ToolException;


//
public interface DeployStep {
    public boolean isDataValid();
    public boolean isBuilt(OtterProject project);
    public boolean isSelectable(OtterProject project, DeployStep[] steps);
    public void validateData() throws DataValidationException;
    public boolean isDataEqual(OtterProject project);
    public void build(OtterProject project, WriteListener listener) throws DataValidationException, ToolException;
    public void read(OtterProject project);
    public void write(OtterProject project) throws DataValidationException;
    public void refresh();
    public void clearAll();
}
