/*
 * Enhydra Java Application Server Project
 *
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific terms governing rights and limitations
 * under the license.
 *
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 *
 * Contributor(s):
 * Paul Mahar
 *
 */
package org.enhydra.kelp.common.node;

//
public interface PropertyKeys {
    public final static String   NAME_WORKING_DIR =
        "WorkingDirectory";                                       // nores
    public final static String   NAME_AUTO_PACK =
        "enable.auto.packages";                                   // nores
    public final static String   NAME_LIBRARIES = "Libraries";    // nores
    public final static String   NAME_GENTO =
        "GenerateSourceToOutDir";                                 // nores
    public final static String   NAME_XMLC_CUSTOM =
        "enhydra.xmlc.custom";                                    // nores
    public final static String   NAME_XMLC_TYPE =
        "enhydra.xmlc.classNameType";                             // nores
    public final static String   NAME_XMLC_OPTION_FILEPATH =
        "enhydra.xmlc.optionFile";                                // nores
    public final static String   NAME_XMLC_PARAMETERS =
        "enhydra.xmlc.parameters";                                // nores
    public final static String   NAME_SELECTED = "enhydra.selected";    // nores
    public final static String   NAME_RESOURCE_STATIC =
        "enhydra.resource.static";                                // nores
    public final static String   VALUE_ENHYDRA = "Enhydra";       // nores

    // directory names
    public final static String[] DEFAULT_CONTENT = {
        "css", "gif", "jpg", "js", "jsp", "wbmp"
    };                                                            // nores
    public final static String PROP_PROJECT_ROOT = "enhydra.xmlc.project.root";
    public final static String PROP_SRC_DIR = "enhydra.xmlc.src.dir";

    //
    public final String          XMLC_DOC_TYPES =
        "enhydra.xmlc.docTypes";                                  // nores
    public final String          XMLC_BUILD = "enhydra.xmlc.build";    // nores
    public final String          XMLC_PRINT_DOM =
        "enhydra.xmlc.printDOM";                                  // nores
    public final String          XMLC_PRINT_PARSE =
        "enhydra.xmlc.printParse";                                // nores
    public final String          XMLC_PRINT_DOC =
        "enhydra.xmlc.printDoc";                                  // nores
    public final String          XMLC_VERBOSE =
        "enhydra.xmlc.verbose";                                   // nores
    public final String          XMLC_PRINT_ACCESSOR =
        "enhydra.xmlc.printAccessor";                             // nores
    public final String          XMLC_OUTPUT_FILENAME =
        "enhydra.xmlc.outputToFilename";                          // nores
    public final String          XMLC_MAP_PACKAGE_FROM =
        "enhydra.xmlc.map.package.fromFolder";                    // nores
    public final String          XMLC_MAP_PACKAGE_TO =
        "enhydra.xmlc.map.package.toPackage";                     // nores
    public final String          XMLC_MAP_PACKAGE_LENGTH =
        "enhydra.xmlc.map.package.length";                        // nores
    public final String          XMLC_MAP_SCOPE =
        "enhydra.xmlc.map.scope";                                 // nores
    public final String          DEPLOY_CONTENT_TYPES =
        "enhydra.deploy.contentTypes";                            // nores
    public final String          DEPLOY_CONTENT_ENABLE =
        "enhydra.deploy.content.enable";                            // nores
    public final String          DEPLOY_RUN_ENABLE =
        "enhydra.deploy.run.enable";                            // nores

    public final String          DEPLOY_TYPE =
        "enhydra.deploy.type";                                  // nores
    public final String          DEPLOY_BUILD =
        "enhydra.deploy.build";                                   // nores
    public final String          DEPLOY_ECHO = "enhydra.deploy.echo";    // nores
    public final String          DEPLOY_OVERWRITE =
        "enhydra.deploy.overwrite";                               // nores
    public final String          DEPLOY_PATH_ROOT =
        "enhydra.deploy.root";                                    // nores
    public final String          DEPLOY_PATH_BOOTSTRAP =
        "enhydra.deploy.bootstrap";                               // nores
    public final String          DEPLOY_INPUT_FILTER =
        "enhydra.deploy.input.filter";                            // nores
    public final String          DEPLOY_INPUT_ENABLE =
        "enhydra.deploy.input.enable";                            // nores
    public final String          DEPLOY_PATH_INPUT =
        "enhydra.deploy.input";                                   // nores
    public final String          DEPLOY_PATH_RESOURCE =
        "enhydra.deploy.resource";                                // nores
    public final String          DEPLOY_TABLE_LENGTH =
        "enhydra.deploy.table.length";                            // nores
    public final String          DEPLOY_TABLE_FIND =
        "enhydra.deploy.table.find";                              // nores
    public final String          DEPLOY_TABLE_REPLACE =
        "enhydra.deploy.table.replace";                           // nores
    public final String          DEPLOY_STARTUP_JAVA =
        "enhydra.deploy.startup.java";                            // nores
    public final String          DEPLOY_STARTUP_RUN =
        "enhydra.deploy.startup.run";                             // nores
    public final String          ARCHIVE_PROPERTIES =
        "enhydra.archive.properties";                             // nores
    public final String          AUTO_DEPLOY_FILE =
        "enhydra.deploy.file";                             // nores
    public final String          DODS_BUILD =
        "enhydra.dods.build";                             // nores
    public final String          DODS_TYPE =
        "enhydra.dods.type";                                  // nores
    public final String          DODS_PATH_ROOT =
        "enhydra.dods.root";                                    // nores
    public final String          DODS_OVERWRITE =
        "enhydra.dods.overwrite";                               // nores
    public final String          DODS_PATH_BOOTSTRAP =
        "enhydra.dods.bootstrap";                               // nores
    public final String          DODS_ECHO = "enhydra.dods.echo";    // nores
    public final String          NAME_DODS_PARAMETERS =
      "DodsParameters";        // nores
    public final String          NAME_DOML_FILEPATH =
      "DomlFilepath";               // nores
    public final String          DODS_PROJECT_JAVA_PATH =
      "enhydra.dods.java.project.path";               // nores
    public final String          DODS_ENHYDRA_PATH =
      "DodsEnhydraPath";               // nores
    public final String          NAME_DODS_ROOTPATH =
      "DodsRootPath";               // nores
    public final String          NAME_DODS_DOCUMENTATION_HTML =
      "DocumentationHtml";               // nores
    public final String          NAME_DODS_DOCUMENTATION_PDF =
      "DocumentationPdf";               // nores
    public final String          NAME_DODS_DOCUMENTATION_XMI =
      "DocumentationXmi";               // nores
    public final String          NAME_DODS_DOCUMENTATION_PTL =
      "DocumentationPtl";               // nores
    public final String          NAME_DODS_TEMPLATE_SET =
      "DodsTemplateSet";               // nores

}
