/*
 * Enhydra Java Application Server Project
 *
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific terms governing rights and limitations
 * under the License.
 *
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 *
 * Contributor(s):
 * Lisa Reese
 *
 */

package org.enhydra.kelp.forte;

import java.awt.Image;
import java.beans.*;

import org.openide.util.NbBundle;

/** Description of {@link DeploySettings}.
 *
 * @author rees0234
 */
public class DeploySettingsBeanInfo extends SimpleBeanInfo {

    public PropertyDescriptor[] getPropertyDescriptors () {
        try {                    
            PropertyDescriptor deployRoot = new PropertyDescriptor ("deployRoot", DeploySettings.class);            
            deployRoot.setDisplayName (NbBundle.getMessage (DeploySettingsBeanInfo.class, "PROP_enhydra.deploy.root"));
            deployRoot.setShortDescription (NbBundle.getMessage (DeploySettingsBeanInfo.class, "HINT_enhydra.deploy.root"));
            return new PropertyDescriptor[] { deployRoot};
        } catch (IntrospectionException ie) {
            if (Boolean.getBoolean ("netbeans.debug.exceptions"))
                ie.printStackTrace ();
            return null;
        }
 
    }
    
    public BeanDescriptor getBeanDescriptor()
    {
        return new BeanDescriptor(DeploySettings.class, DeploySettingsCustomizer.class);
    }
    
    private static Image icon, icon32;
    public Image getIcon (int type) {
        if (type == BeanInfo.ICON_COLOR_16x16 || type == BeanInfo.ICON_MONO_16x16) {
            if (icon == null)
                icon = loadImage ("enhydraObject.gif");
            return icon;
        } else {
            if (icon32 == null)
                icon32 = loadImage ("enhdyraObject32.gif");
            return icon32;
        }
    }

}
