package org.enhydra.kelp.ant.deployer;

import java.awt.*;
import org.enhydra.tool.swing.layout.*;
import javax.swing.*;
import org.enhydra.kelp.ant.node.AntProject;
import org.enhydra.kelp.common.node.OtterProject;
import java.util.ResourceBundle;
import org.enhydra.kelp.common.node.OtterFileNode;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class AntDeployInputPanel extends JPanel {
  static ResourceBundle res = ResourceBundle.getBundle(
                            "org.enhydra.kelp.common.Res");

    XYLayout xYLayout1 = new XYLayout();
    JLabel jLabelHeading = new JLabel();
    JTextArea jTextDescr = new JTextArea();

    private AntProject project = null;
    JCheckBox jCheckEnable = new JCheckBox();
    JTabbedPane tab = new JTabbedPane();
    AntDeployInputTemplatesPanel documentsPanel =
            new AntDeployInputTemplatesPanel();
    AntDeployInputReplacementsPanel replacementsPanel =
            new AntDeployInputReplacementsPanel();

    public AntDeployInputPanel() {
        try {
            jbInit();
            pmInit();
        }
        catch(Exception ex) {
            ex.printStackTrace();
        }
    }

    private void pmInit() {
        tab.add(res.getString("Documents"), documentsPanel);
        tab.add(res.getString("Replacements"), replacementsPanel);
    }

    void jbInit() throws Exception {
        jLabelHeading.setFont(new java.awt.Font("Dialog", 1, 12));
        jLabelHeading.setText(res.getString("Input_templates"));
        this.setLayout(xYLayout1);
        jTextDescr.setBackground(SystemColor.control);
        jTextDescr.setEnabled(false);
        jTextDescr.setFont(new java.awt.Font("SansSerif", 0, 12));
        jTextDescr.setDisabledTextColor(SystemColor.controlText);
        jTextDescr.setEditable(false);
        jTextDescr.setText(res.getString("Input_description"));
        jTextDescr.setLineWrap(true);
        jTextDescr.setWrapStyleWord(true);
        xYLayout1.setWidth(540);
        xYLayout1.setHeight(404);
        jCheckEnable.setText(res.getString("Enable_input_deployment"));
        this.add(jLabelHeading,                new XYConstraints(13, 1, 96, 25));
        this.add(jTextDescr,                        new XYConstraints(13, 26, 519, 50));
        this.add(jCheckEnable,                                     new XYConstraints(13, 75, 180, 19));
        this.add(tab,                              new XYConstraints(7, 99, 525, 272));
    }

    public void setProject(OtterProject otterProject){
        replacementsPanel.setProject(otterProject);
        documentsPanel.setProject(otterProject);
        if(otterProject instanceof AntProject) {
            project = (AntProject) otterProject;
            initOptions();
        }
        else
            System.err.println("DEBUG project must be AntProject");//FIXME throw Exception
    }

    private void initOptions(){
        if(project.getProperty(AntProject.DEPLOY_INPUT_ENABLED).equalsIgnoreCase("true"))
            jCheckEnable.setSelected(true);
        else
            jCheckEnable.setSelected(false);
        //read all input files and fill documents panel
    }

    protected void setNodes(OtterFileNode[] n) {
        //documentsPanel.setNodes(n);
    }

}