/*
 * Enhydra Java Application Server Project
 *
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific terms governing rights and limitations
 * under the License.
 *
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 *
 * Contributor(s):
 * Paul Mahar
 *
 */
package org.enhydra.kelp.common.deployer;

// ToolBox imports
import org.enhydra.tool.common.DataValidationException;

// Kelp imports
import org.enhydra.kelp.common.node.OtterProject;

//
public class DeployStepUtil {
    public static boolean isBuilt(DeployStep step, boolean ran,
                                        OtterProject project) {
        if (ran) {
            if (!step.isDataValid()) {
                ran = false;
            } else if (!step.isDataEqual(project)) {
                ran = false;
            }
        }
        return ran;
    }

    public static boolean isDataValid(DeployStep step) {
        boolean dataValid = true;

        try {
            step.validateData();
        } catch (DataValidationException e) {
            System.err.print(e.getValidationMessage());
            dataValid = false;
        }
        return dataValid;
    }

}
