
package org.enhydra.kelp.eclipse.enhydraWizard;

import java.lang.reflect.InvocationTargetException;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.eclipse.core.internal.events.BuildManager;
import org.eclipse.core.internal.resources.Workspace;
import org.eclipse.core.resources.ICommand;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IProjectDescription;
import org.eclipse.core.resources.IResource;
//import org.eclipse.core.resources.IWorkspace;
import org.eclipse.core.resources.IWorkspaceRoot;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IConfigurationElement;
import org.eclipse.core.runtime.IPath;
import org.eclipse.core.runtime.Path;

import org.eclipse.jdt.internal.ui.preferences.NewJavaProjectPreferencePage;
import org.eclipse.jdt.internal.ui.util.ExceptionHandler;
import org.eclipse.jface.operation.IRunnableWithProgress;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.jface.wizard.Wizard;
import org.eclipse.ui.IEditorReference;
import org.eclipse.ui.INewWizard;
import org.eclipse.ui.IViewPart;
import org.eclipse.ui.IViewReference;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.actions.WorkspaceModifyDelegatingOperation;
import org.eclipse.ui.externaltools.internal.core.DefaultRunnerContext;
import org.eclipse.ui.externaltools.internal.core.ExternalTool;
import org.eclipse.ui.externaltools.internal.core.ExternalToolsPlugin;
import org.eclipse.ui.externaltools.internal.core.ExternalToolsRegistry;
import org.eclipse.ui.part.ISetSelectionTarget;
import org.eclipse.ui.wizards.newresource.BasicNewProjectResourceWizard;
import org.enhydra.kelp.eclipse.KelpPlugin;
import org.enhydra.kelp.eclipse.codegen.wizard.EclipseCodeGenWizard;
import org.enhydra.tool.ToolBoxInfo;
import org.enhydra.tool.codegen.Generator;
import org.enhydra.tool.codegen.GeneratorException;
import org.enhydra.tool.codegen.GeneratorOption;
import org.enhydra.tool.codegen.wizard.CodeGenWizard;
import org.enhydra.tool.common.SwingUtil;
import org.eclipse.jdt.internal.ui.JavaPlugin;



/**
 * Insert the type's description here.
 * @see Wizard
 */
public class NewEnhydraProjectWizard extends Wizard implements INewWizard {
	
	private NewEnhydraWizardPage mainPage;
	private NewEnhydraWizardSecondPage javaPage;
	private IConfigurationElement fConfigElement;
	private IWorkbench workbench;
	private IStructuredSelection selection;
	
	/**
	 * The constructor.
	 */
	public NewEnhydraProjectWizard() {
		super();
		
		setDefaultPageImageDescriptor(createImageDescriptor("EnhydraBig.gif"));
		setDialogSettings(KelpPlugin.getDefault().getDialogSettings());
		setWindowTitle(NewEnhydraWizardMessages.getString("NewEnhydraProjectWizard.title"));
	}
	
	/**
	 * Adds a new page to this wizard. The page is inserted at the
	 * end of the page list.
	 *
	 * @param page the new page
	 */
	public void addPages() {
		super.addPages();
						
		mainPage = new NewEnhydraWizardPage("NewEnhydraProjectWizard");
		mainPage.setDescription(NewEnhydraWizardMessages.getString("NewEnhydraProjectWizard.MainPage.description"));
		mainPage.setTitle(NewEnhydraWizardMessages.getString("NewEnhydraProjectWizard.MainPage.title"));
		addPage(mainPage);
		
		javaPage = new NewEnhydraWizardSecondPage(mainPage);
		addPage(javaPage);
	}
	
	public NewEnhydraWizardSecondPage getJavaPage() {
		return javaPage;
	}

	/**
	 * Insert the method's description here.
	 * @see Wizard#performFinish
	 */
	public boolean performFinish() {
		
		
		
		IRunnableWithProgress op= new WorkspaceModifyDelegatingOperation(javaPage.getRunnable());
		try {
			getContainer().run(false, true, op);
		} catch (InvocationTargetException e) {
			String title= NewEnhydraWizardMessages.getString("NewProjectCreationWizard.op_error.title"); //$NON-NLS-1$
			String message= NewEnhydraWizardMessages.getString("NewProjectCreationWizard.op_error.message");			 //$NON-NLS-1$
			ExceptionHandler.handle(e, getShell(), title, message);
			return false;
		} catch  (InterruptedException e) {
			return false;
		}
		BasicNewProjectResourceWizard.updatePerspective(fConfigElement);
		selectAndReveal(javaPage.getJavaProject().getProject());
		createExternalBuilders();

		runEnhydraWizard();
		

		return true;
	}

	private void runEnhydraWizard() {
		EclipseCodeGenWizard wizard;
		IProject project = javaPage.getJavaProject().getProject();

		String prjName = javaPage.getJavaProject().getProject().getName();
		SwingUtil.setLookAndFeelToSystem();	//Dacha add 25.02.2003
		
		try {
			int i;

//Dacha add
			IPath projPath = javaPage.getJavaProject().getProject().getLocation();
			String a = projPath.uptoSegment(projPath.segmentCount() - 1).toString();
			
			
			wizard = new EclipseCodeGenWizard(prjName, a);//Dacha changed to get prj root
//Dacha end

			IWorkspaceRoot myWorkspaceRoot = KelpPlugin.getWorkspace().getRoot();

			wizard.getInnerPanel().initPreferredSize();
			wizard.showDialog(null);

			// Refresh project, so the generated files could be visible	
			//DACHA comment
			//IProject EnhydraProject = myWorkspaceRoot.getProject(prjName);
			
			try {
				//DACHA comment
				//EnhydraProject.refreshLocal(IResource.DEPTH_INFINITE, null);
				project.refreshLocal(IResource.DEPTH_INFINITE, null);				
			} catch (CoreException e) {
				System.err.println(prjName);
			}
		} catch (GeneratorException e) {
			System.err.println(e.getMessage());
		}
	}
/**
 * Creates External tool builder and make apropriate build order
 * todo: add DODS in rebuild
 */	
	private void createExternalBuilders(){
		IProject project = javaPage.getJavaProject().getProject();
	
		ICommand[] commands = new ICommand[0];
		try{
			commands = project.getDescription().getBuildSpec();
		
			ICommand javaBuildCommand = commands[0];	//default for Java Project

			String location = ToolBoxInfo.getEnhydraRoot() + "/bin/ant";
			if (System.getProperty("os.name").toLowerCase().startsWith("windows")) {
				location += ".bat";
			}
			
			//Create XMLC External tool
			ExternalTool antXMLCTool = new ExternalTool();
			
			antXMLCTool.setBlock(true);
			antXMLCTool.setBuildTypes(new String[0]); //default: do not include in any rebuild
			antXMLCTool.setLocation(location);
			antXMLCTool.setArguments("xmlc");
			antXMLCTool.setName("ant xmlc");
			antXMLCTool.setRefreshScope("${project}");
			antXMLCTool.setShowLog(true);
			antXMLCTool.setType(ExternalTool.TOOL_TYPE_PROGRAM);
			antXMLCTool.setWorkingDirectory("${workspace_loc:/"+project.getName()+"}");
			//Create new command for XMLC
			ICommand antXMLCCommand = project.getDescription().newCommand();
			Map argMap = antXMLCTool.toArgumentMap();			
			antXMLCCommand.setArguments(argMap);
			antXMLCCommand.setBuilderName("org.eclipse.ui.externaltools.ExternalToolBuilder");
			
			//Create DeployerExternal tool
			ExternalTool antDeployTool = new ExternalTool();
			
			antDeployTool.setBlock(true);
			antDeployTool.setBuildTypes(new String[0]);//default: do not include in any rebuild
			antDeployTool.setLocation(location);
			antDeployTool.setArguments("deploy");
			antDeployTool.setName("ant deploy");
			antDeployTool.setRefreshScope("${project}");
			antDeployTool.setShowLog(true);
			antDeployTool.setType(ExternalTool.TOOL_TYPE_PROGRAM);
			antDeployTool.setWorkingDirectory("${workspace_loc:/"+project.getName()+"}");
			//Create new command for Deploy
			ICommand antDeployCommand = project.getDescription().newCommand();
			Map argMapDeploy = antDeployTool.toArgumentMap();			
			antDeployCommand.setArguments(argMapDeploy);
			antDeployCommand.setBuilderName("org.eclipse.ui.externaltools.ExternalToolBuilder");
			
			//Create DODSExternal tool
			ExternalTool antDODSTool = new ExternalTool();
			
			antDODSTool.setBlock(true);
			antDODSTool.setBuildTypes(new String[0]);//default: do not include in any rebuild
			antDODSTool.setLocation(location);
			antDODSTool.setArguments("dods");
			antDODSTool.setName("ant dods");
			antDODSTool.setRefreshScope("${project}");
			antDODSTool.setShowLog(true);
			antDODSTool.setType(ExternalTool.TOOL_TYPE_PROGRAM);
			antDODSTool.setWorkingDirectory("${workspace_loc:/"+project.getName()+"}");
			//Create new command for DODS
			ICommand antDODSCommand = project.getDescription().newCommand();
			Map argMapDODS = antDODSTool.toArgumentMap();			
			antDODSCommand.setArguments(argMapDODS);
			antDODSCommand.setBuilderName("org.eclipse.ui.externaltools.ExternalToolBuilder");
			
			//Set new builds order
			commands = new ICommand[4];
			commands[0] = antXMLCCommand;
			commands[1] = antDODSCommand;
			commands[2] = javaBuildCommand;
			commands[3] = antDeployCommand;
			
			IProjectDescription description = project.getDescription();
			description.setBuildSpec(commands);//Set new build order
			project.setDescription(description,null); //Save new description (file".project")
			
		}catch(Exception e){
				e.printStackTrace();
		}	
	}
	
	/**
	 * Selects and reveals the newly added resource in all parts
	 * of the active workbench window's active page.
	 *
	 * @see ISetSelectionTarget
	 */
	protected void selectAndReveal(IResource newResource) {
		selectAndReveal(newResource, workbench.getActiveWorkbenchWindow());
	}

	/**
	 * Attempts to select and reveal the specified resource in all
	 * parts within the supplied workbench window's active page.
	 * <p>
	 * Checks all parts in the active page to see if they implement <code>ISetSelectionTarget</code>,
	 * either directly or as an adapter. If so, tells the part to select and reveal the
	 * specified resource.
	 * </p>
	 *
	 * @param resource the resource to be selected and revealed
	 * @param window the workbench window to select and reveal the resource
	 * 
	 * @see ISetSelectionTarget
	 */
	public static void selectAndReveal(IResource resource, IWorkbenchWindow window) {
		// validate the input
		if (window == null || resource == null)
			return;
		IWorkbenchPage page = window.getActivePage();
		if (page == null)
			return;
	
		// get all the view and editor parts
		List parts = new ArrayList();
		/**/
		IViewReference[] viewRefs = page.getViewReferences();
		IViewPart[] viewParts = new IViewPart[viewRefs.length];
		for(int i = 0; i < viewRefs.length; i++) {
			viewParts[i] = viewRefs[i].getView(true);
		}
		/**/
		parts.addAll(Arrays.asList(viewParts));
		IEditorReference refs[] = page.getEditorReferences();
		for (int i = 0; i < refs.length; i++) {
			if(refs[i].getPart(false) != null)
				parts.add(refs[i].getPart(false));
		}
		
		final ISelection selection = new StructuredSelection(resource);
		Iterator enum = parts.iterator();
		while (enum.hasNext()) {
			IWorkbenchPart part = (IWorkbenchPart) enum.next();
			
			// get the part's ISetSelectionTarget implementation
			ISetSelectionTarget target = null;
			if (part instanceof ISetSelectionTarget)
				target = (ISetSelectionTarget) part;
			else
				target = (ISetSelectionTarget) part.getAdapter(ISetSelectionTarget.class);
				
			if (target != null) {
				// select and reveal resource
				final ISetSelectionTarget finalTarget = target;
				window.getShell().getDisplay().asyncExec(new Runnable() {
					public void run() {
						finalTarget.selectReveal(selection);
					}
				});
			}
		}
	}
	/**
	 * Insert the method's description here.
	 * @see Wizard#init
	 */
	public void init(IWorkbench workbench, IStructuredSelection selection)  {
		this.workbench = workbench;
		this.selection = selection;

		setWindowTitle(NewEnhydraWizardMessages.getString("NewEnhydraProjectWizard.MainPage.title"));
		setDefaultPageImageDescriptor(createImageDescriptor("EnhydraBig.gif"));
		setNeedsProgressMonitor(true);
	}
	
	/**
	 * Returns the image descriptor with the given relative path.
	 */
/*	private ImageDescriptor getImageDescriptor(String relativePath) {
		String iconPath = "icons/full/";
		try {
			AbstractUIPlugin plugin = (AbstractUIPlugin) Platform.getPlugin(PlatformUI.PLUGIN_ID);
			URL installURL = plugin.getDescriptor().getInstallURL();
			URL url = new URL(installURL, iconPath + relativePath);
			return ImageDescriptor.createFromURL(url);
		}
		catch (MalformedURLException e) {
			// Should not happen
			e.printStackTrace();
			return null;
		}
	}
*/	
	/**
	 * Utility method to create an <code>ImageDescriptor</code>
	 * from a path to a file.
	 */
	private ImageDescriptor createImageDescriptor(String path) {
		URL baseURL = KelpPlugin.getDefault().getDescriptor().getInstallURL();
		String iconPath = "icons/";
		try {
			URL url = new URL(baseURL, iconPath + path);
			return ImageDescriptor.createFromURL(url);
		} catch (MalformedURLException e) {
		}
		return ImageDescriptor.getMissingImageDescriptor();
	}
	
	/*
	 * Stores the configuration element for the wizard.  The config element will be used
	 * in <code>performFinish</code> to set the result perspective.
	 */
	public void setInitializationData(IConfigurationElement cfig, String propertyName, Object data) {
		fConfigElement= cfig;
	}
	
	public boolean canFinish() {
		if (javaPage.getJavaProject() == null) {
			return false;
		}
		return true;
	}
	
	
}
