package org.enhydra.kelp.eclipse.ui.launcher;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.debug.core.ILaunchConfigurationWorkingCopy;
import org.eclipse.jdt.debug.ui.launchConfigurations.JavaArgumentsTab;
import org.eclipse.jdt.internal.debug.ui.JDIDebugUIPlugin;
import org.eclipse.jdt.launching.IJavaLaunchConfigurationConstants;
import org.enhydra.tool.ToolBoxInfo;

/**
 * @author Administrator
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class EnhydraArgumentsTab extends JavaArgumentsTab {

	private static final String ENHYDRA_PROGRAM_ARGUMENTS = "conf/multiserver.conf";

	/**
	 * Constructor for EnhydraArgumentsTab.
	 */
	public EnhydraArgumentsTab() {
		super();
	}


	/**
	 * @see org.eclipse.debug.ui.ILaunchConfigurationTab#setDefaults(ILaunchConfigurationWorkingCopy)
	 */
	public void setDefaults(ILaunchConfigurationWorkingCopy configuration) {
		super.setDefaults(configuration);

		String progArgs = "";
		String workDir = "";
		String prjName = "";

		try {
		    //24.03.2003
			configuration.setAttribute(IJavaLaunchConfigurationConstants.ATTR_VM_ARGUMENTS, "-Denhydra.home="+"\""+ToolBoxInfo.getEnhydraRoot()+"\"");
			
			prjName = configuration.getAttribute(IJavaLaunchConfigurationConstants.ATTR_PROJECT_NAME, EMPTY_STRING);
			// Program arguments defaults to ENHYDRA_PROGRAM_ARGUMENTS
			progArgs = configuration.getAttribute(IJavaLaunchConfigurationConstants.ATTR_PROGRAM_ARGUMENTS, EMPTY_STRING);
			if (progArgs.compareTo(ENHYDRA_PROGRAM_ARGUMENTS) != 0)
				configuration.setAttribute(IJavaLaunchConfigurationConstants.ATTR_PROGRAM_ARGUMENTS, ENHYDRA_PROGRAM_ARGUMENTS);
			// Work directory defaults to <project name>/output
			workDir = configuration.getAttribute(IJavaLaunchConfigurationConstants.ATTR_WORKING_DIRECTORY, EMPTY_STRING);
			if (progArgs.compareTo(EMPTY_STRING) == 0) {
				prjName = configuration.getAttribute(IJavaLaunchConfigurationConstants.ATTR_PROJECT_NAME, EMPTY_STRING);
				configuration.setAttribute(IJavaLaunchConfigurationConstants.ATTR_WORKING_DIRECTORY, prjName.concat("/output"));
			}
		} catch (CoreException e) {
			JDIDebugUIPlugin.log(e);
		}
	}

}
