package org.enhydra.kelp.eclipse.actions;

import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IResource;
import org.eclipse.jdt.core.IJavaElement;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;
import org.enhydra.kelp.ant.deployer.AntDeployTool;

import KelpEclipse21.KelpEclipse21Plugin;

/**
 * Insert the type's description here.
 * @see IWorkbenchWindowActionDelegate
 */
public class DeployAction implements IWorkbenchWindowActionDelegate {
	/**
	 * The constructor.
	 */
	public DeployAction() {
	}

	/**
	 * Insert the method's description here.
	 * @see IWorkbenchWindowActionDelegate#run
	 */
	public void run(IAction action)  {
		IProject project = null;
		String prjName = null;
		String prjPath = null;

		IWorkbenchPage page = KelpEclipse21Plugin.getDefault().getWorkbench().getActiveWorkbenchWindow().getActivePage();
		if (page != null) {
			ISelection selection = page.getSelection();
			if (selection instanceof IStructuredSelection) {
				IStructuredSelection ss = (IStructuredSelection)selection;
				if (!ss.isEmpty()) {
					Object obj = ss.getFirstElement();
					if (obj instanceof IJavaElement) {
						IResource res =((IJavaElement)obj).getResource();
						if (res == null)
							project = ((IJavaElement)obj).getJavaProject().getProject();
						else
							project = res.getProject();
							
					}
					if (obj instanceof IResource) {
							project = ((IResource)obj).getProject();
					}
				}
			}
		}
		if (project != null) {
			prjName = project.getName();
			prjPath = project.getLocation().toString();
		
//---------------------Dacha---------------------------------

			AntDeployTool.main(new String[]{prjPath});
		}else
			System.err.println("Fail to start Deployer, no project is selected!");
	}

	/**
	 * Insert the method's description here.
	 * @see IWorkbenchWindowActionDelegate#selectionChanged
	 */
	public void selectionChanged(IAction action, ISelection selection)  {
	}

	/**
	 * Insert the method's description here.
	 * @see IWorkbenchWindowActionDelegate#dispose
	 */
	public void dispose()  {
	}

	/**
	 * Insert the method's description here.
	 * @see IWorkbenchWindowActionDelegate#init
	 */
	public void init(IWorkbenchWindow window)  {
	}
}
