package org.enhydra.kelp.eclipse.enhydraWizard;

import java.lang.reflect.InvocationTargetException;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import org.eclipse.ui.IEditorReference;
import org.eclipse.ui.IViewPart;
import org.eclipse.ui.IViewReference;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.core.internal.events.BuildCommand;
import org.eclipse.core.resources.ICommand;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IProjectDescription;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.resources.IWorkspaceRoot;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IConfigurationElement;
import org.eclipse.core.runtime.IPath;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.operation.IRunnableWithProgress;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.jface.wizard.IWizardPage;
import org.eclipse.jface.wizard.Wizard;
import org.eclipse.ui.INewWizard;
import org.eclipse.ui.actions.WorkspaceModifyDelegatingOperation;
import org
	.eclipse
	.ui
	.externaltools
	.internal
	.launchConfigurations
	.ExternalToolsUtil;
import org.eclipse.ui.externaltools.internal.model.ExternalToolBuilder;
import org.eclipse.ui.externaltools.internal.model.IExternalToolConstants;
import org.eclipse.ui.externaltools.internal.registry.ExternalToolMigration;
import org.eclipse.ui.part.ISetSelectionTarget;
import org.eclipse.ui.wizards.newresource.BasicNewProjectResourceWizard;
import org.enhydra.kelp.eclipse.codegen.wizard.EclipseCodeGenWizard;
import org.enhydra.tool.ToolBoxInfo;
import org.enhydra.tool.codegen.GeneratorException;
import org.enhydra.tool.common.SwingUtil;
//import org.enhydra.kelp.eclipse.codegen.wizard.EclipseCodeGenWizard;
//import org.enhydra.tool.codegen.GeneratorException;
//import org.enhydra.tool.common.SwingUtil;

import KelpEclipse21.KelpEclipse21Plugin;

/**
 * @see Wizard
 */
public class NewEnhydraProjectWizard extends Wizard implements INewWizard {

	private NewEnhydraWizardPage mainPage;
	private NewEnhydraWizardSecondPage javaPage;

	private IWorkbench workbench;
	private IStructuredSelection selection;
	private IConfigurationElement fConfigElement;

	/**
	 */
	public NewEnhydraProjectWizard() {
		super();

		//setDefaultPageImageDescriptor(createImageDescriptor("EnhydraBig.gif"));
		setDialogSettings(KelpEclipse21Plugin.getDefault().getDialogSettings());
		setWindowTitle(
			NewEnhydraWizardMessages.getString(
				"NewEnhydraProjectWizard.title"));
	}

	/**
	 * Adds a new page to this wizard. The page is inserted at the
	 * end of the page list.
	 *
	 * @param page the new page
	 */
	public void addPages() {
		super.addPages();

		mainPage = new NewEnhydraWizardPage("NewEnhydraProjectWizard");
		mainPage.setDescription(
			NewEnhydraWizardMessages.getString(
				"NewEnhydraProjectWizard.MainPage.description"));
		mainPage.setTitle(
			NewEnhydraWizardMessages.getString(
				"NewEnhydraProjectWizard.MainPage.title"));
		addPage(mainPage);

		javaPage = new NewEnhydraWizardSecondPage(mainPage);
		addPage((IWizardPage) javaPage);
	}

	/**
	 * @see Wizard#performFinish
	 */
	public boolean performFinish() {
		IRunnableWithProgress op =
			new WorkspaceModifyDelegatingOperation(javaPage.getRunnable());
		try {
			getContainer().run(false, true, op);
		} catch (InvocationTargetException e) {
			String title = NewEnhydraWizardMessages.getString("NewProjectCreationWizard.op_error.title"); //$NON-NLS-1$
			String message = NewEnhydraWizardMessages.getString("NewProjectCreationWizard.op_error.message"); //$NON-NLS-1$
			/*z21			
			 * ExceptionHandler.handle(e, getShell(), title, message);
			 */
			MessageDialog.openError(getShell(), "Error", message);
			return false;
		} catch (InterruptedException e) {
			return false;
		}
		BasicNewProjectResourceWizard.updatePerspective(fConfigElement);
		selectAndReveal(javaPage.getJavaProject().getProject());
		createExternalBuilders();

		runEnhydraWizard();

		return true;
	}

	/**
	 * @see Wizard#init
	 */
	public void init(IWorkbench workbench, IStructuredSelection selection) {
		this.workbench = workbench;
		this.selection = selection;

		setWindowTitle(
			NewEnhydraWizardMessages.getString(
				"NewEnhydraProjectWizard.MainPage.title"));
		setDefaultPageImageDescriptor(createImageDescriptor("EnhydraBig.gif"));
		setNeedsProgressMonitor(true);
	}

	/*
	 * Stores the configuration element for the wizard.  The config element will be used
	 * in <code>performFinish</code> to set the result perspective.
	 */
	public void setInitializationData(
		IConfigurationElement cfig,
		String propertyName,
		Object data) {
		fConfigElement = cfig;
	}

	/**
	 */
	public boolean canFinish() {
		if (javaPage.getJavaProject() == null) {
			return false;
		}
		return true;
	}

	/**
	 * Selects and reveals the newly added resource in all parts
	 * of the active workbench window's active page.
	 *
	 * @see ISetSelectionTarget
	 */
	protected void selectAndReveal(IResource newResource) {
		selectAndReveal(newResource, workbench.getActiveWorkbenchWindow());
	}

	/**
	 * Attempts to select and reveal the specified resource in all
	 * parts within the supplied workbench window's active page.
	 * <p>
	 * Checks all parts in the active page to see if they implement <code>ISetSelectionTarget</code>,
	 * either directly or as an adapter. If so, tells the part to select and reveal the
	 * specified resource.
	 * </p>
	 *
	 * @param resource the resource to be selected and revealed
	 * @param window the workbench window to select and reveal the resource
	 * 
	 * @see ISetSelectionTarget
	 */
	public static void selectAndReveal(
		IResource resource,
		IWorkbenchWindow window) {
		// validate the input
		if (window == null || resource == null)
			return;
		IWorkbenchPage page = window.getActivePage();
		if (page == null)
			return;

		// get all the view and editor parts
		List parts = new ArrayList();
		/**/
		IViewReference[] viewRefs = page.getViewReferences();
		IViewPart[] viewParts = new IViewPart[viewRefs.length];
		for (int i = 0; i < viewRefs.length; i++) {
			viewParts[i] = viewRefs[i].getView(true);
		}
		/**/
		parts.addAll(Arrays.asList(viewParts));
		IEditorReference refs[] = page.getEditorReferences();
		for (int i = 0; i < refs.length; i++) {
			if (refs[i].getPart(false) != null)
				parts.add(refs[i].getPart(false));
		}

		final ISelection selection = new StructuredSelection(resource);
		Iterator enum = parts.iterator();
		while (enum.hasNext()) {
			IWorkbenchPart part = (IWorkbenchPart) enum.next();

			// get the part's ISetSelectionTarget implementation
			ISetSelectionTarget target = null;
			if (part instanceof ISetSelectionTarget)
				target = (ISetSelectionTarget) part;
			else
				target =
					(ISetSelectionTarget) part.getAdapter(
						ISetSelectionTarget.class);

			if (target != null) {
				// select and reveal resource
				final ISetSelectionTarget finalTarget = target;
				window.getShell().getDisplay().asyncExec(new Runnable() {
					public void run() {
						finalTarget.selectReveal(selection);
					}
				});
			}
		}
	}

	/**
	 * Utility method to create an <code>ImageDescriptor</code>
	 * from a path to a file.
	 */
	private ImageDescriptor createImageDescriptor(String path) {
		URL baseURL =
			KelpEclipse21Plugin.getDefault().getDescriptor().getInstallURL();
		String iconPath = "icons/";
		try {
			URL url = new URL(baseURL, iconPath + path);
			return ImageDescriptor.createFromURL(url);
		} catch (MalformedURLException e) {
		}
		return ImageDescriptor.getMissingImageDescriptor();
	}

	private void runEnhydraWizard() {
		EclipseCodeGenWizard wizard;
		IProject project = javaPage.getJavaProject().getProject();

		String prjName = javaPage.getJavaProject().getProject().getName();
		SwingUtil.setLookAndFeelToSystem(); //Dacha add 25.02.2003

		try {
			int i;

			//	  Dacha add
			IPath projPath =
				javaPage.getJavaProject().getProject().getLocation();
			String a =
				projPath.uptoSegment(projPath.segmentCount() - 1).toString();

			wizard = new EclipseCodeGenWizard(prjName, a);
			//Dacha changed to get prj root
			//	  Dacha end

			IWorkspaceRoot myWorkspaceRoot =
				KelpEclipse21Plugin.getWorkspace().getRoot();

			wizard.getInnerPanel().initPreferredSize();
			wizard.showDialog(null);

			// Refresh project, so the generated files could be visible	
			//DACHA comment
			//IProject EnhydraProject = myWorkspaceRoot.getProject(prjName);

			try {
				//DACHA comment
				//EnhydraProject.refreshLocal(IResource.DEPTH_INFINITE, null);
				project.refreshLocal(IResource.DEPTH_INFINITE, null);
			} catch (CoreException e) {
				System.err.println(prjName);
			}
		} catch (GeneratorException e) {
			System.err.println(e.getMessage());
		}
	}

	/**
	 * Creates External tool builder and make apropriate build order
	 * todo: add DODS in rebuild
	 */
	private void createExternalBuilders() {
		
/*------------------Dacha&Zorica--------------------*/
		
		String BUILDER_ID = "org.eclipse.ui.externaltools.ExternalToolBuilder";

		IProject project = javaPage.getJavaProject().getProject();
		IProjectDescription desc;
		ICommand[] commands = new ICommand[0];
		try {
			desc = project.getDescription();
			commands = desc.getBuildSpec();

			ICommand javaBuildCommand = commands[0]; //default for Java Project
			String location = ToolBoxInfo.getEnhydraRoot() + "/bin/ant";
			if (System.getProperty("os.name").toLowerCase().startsWith("windows")) {
				location += ".bat";
			}

			//add builder to project

			//xmlc
			BuildCommand antXMLCCommand = (BuildCommand) desc.newCommand();
			antXMLCCommand.setBuilderName(BUILDER_ID);
			HashMap argMap = new HashMap();

			argMap.put("!{tool_name}", "ant xmlc");
			argMap.put("!{tool_type}", IExternalToolConstants.TOOL_TYPE_PROGRAM);
			argMap.put("!{tool_args}", "xmlc");
			argMap.put("!{tool_refresh}", "${project}");
			argMap.put("!{tool_build_types}", IExternalToolConstants.BUILD_TYPE_INCREMENTAL);
			argMap.put("!{tool_dir}", "${workspace_loc:/" + project.getName() + "}");
			argMap.put("!{tool_loc}", location);
			argMap.put("!{tool_block}", "true");

			antXMLCCommand.setArguments(argMap);

			//dods				
			BuildCommand antDODSCommand = (BuildCommand) desc.newCommand();
			antDODSCommand.setBuilderName(BUILDER_ID);
			argMap = new HashMap();

			argMap.put("!{tool_name}", "ant dods");
			argMap.put("!{tool_type}", IExternalToolConstants.TOOL_TYPE_PROGRAM);
			argMap.put("!{tool_args}", "dods");
			argMap.put("!{tool_refresh}", "${project}");
			argMap.put("!{tool_build_types}", IExternalToolConstants.BUILD_TYPE_INCREMENTAL);
			argMap.put("!{tool_dir}", "${workspace_loc:/" + project.getName() + "}");
			argMap.put("!{tool_loc}", location);
			argMap.put("!{tool_block}", "true");

			antDODSCommand.setArguments(argMap);

			//deploy
			BuildCommand antDeployCommand = (BuildCommand) desc.newCommand();
			antDeployCommand.setBuilderName(BUILDER_ID);
			argMap = new HashMap();

			argMap.put("!{tool_name}", "ant deploy");
			argMap.put("!{tool_type}", IExternalToolConstants.TOOL_TYPE_PROGRAM);
			argMap.put("!{tool_args}", "deploy");
			argMap.put("!{tool_refresh}", "${project}");
			argMap.put("!{tool_build_types}", IExternalToolConstants.BUILD_TYPE_INCREMENTAL);
			argMap.put("!{tool_dir}", "${workspace_loc:/" + project.getName() + "}");
			argMap.put("!{tool_loc}", location);
			argMap.put("!{tool_block}", "true");

			antDeployCommand.setArguments(argMap);


			// Add it before other builders.
			//Set new builds order
			commands = new ICommand[4];
			commands[0] = antXMLCCommand;
			commands[1] = antDODSCommand;
			commands[2] = javaBuildCommand;
			commands[3] = antDeployCommand;

			desc.setBuildSpec(commands);
			project.setDescription(desc, null);

		} catch (CoreException e) {
			e.printStackTrace();
		}

	}

}
