package org.enhydra.kelp.jbuilder;

/**
 * <p>Title: Enhydra Tools</p>
 * <p>Description: Class for invokation Enhydra tools: xml compiler, deployer
 * and dods</p>
 * @author Strahinja Videnovic
 * @version 1.0
 */

import com.borland.primetime.*;
import com.borland.jbuilder.*;
import com.borland.primetime.ide.*;

import javax.swing.*;
import javax.swing.Icon;
import java.net.URL;
import com.borland.primetime.util.Icons;
//import java.awt.event.*;
import org.enhydra.kelp.jbuilder.actions.*;
import com.borland.primetime.util.Images;

public class EnhydraTools {

  public static final EnhydraGroup GROUP_Enhydra;
  public static final Action ACTION_XMLC;
  public static final Action ACTION_DEPLOYER;
  public static final Action ACTION_DODS;
  private final static String MENU_ICON = "/media/menu_16x16.gif";
  private static Icon icon;

  public EnhydraTools() {
  }

  static
  {
    GROUP_Enhydra = new EnhydraGroup("Enhydra Tools", 'E', "",
               Icons.getIcon(org.enhydra.kelp.jbuilder.EnhydraTools.class, MENU_ICON),
               true /*pop up*/);
    ACTION_XMLC = new XMLCAction("XML Compiler", 'X');
    ACTION_DEPLOYER = new DeployerAction("Deployer", 'D');
    ACTION_DODS = new DODSAction("DODS", 'O');

  }

  public static void initOpenTool(byte major,
         byte minor) {

      // Check OpenTools version number
      if (major != PrimeTime.CURRENT_MAJOR_VERSION)
          return;

      // Add a new menu item to the Help menu
      JBuilderMenu.GROUP_ToolsStandard.add(GROUP_Enhydra);
      GROUP_Enhydra.add(ACTION_XMLC);
      GROUP_Enhydra.add(ACTION_DEPLOYER);
      GROUP_Enhydra.add(ACTION_DODS);
//      Browser.addToolBarGroup(GROUP_Enhydra); // todo ne fercera bas...
  }

}