package org.enhydra.kelp.jdev;


import javax.swing.JPanel;
import java.awt.*;
import javax.swing.*;
import oracle.bali.ewt.wizard.WizardEvent;
import oracle.bali.ewt.wizard.WizardValidateListener;
import oracle.bali.ewt.event.Cancelable;
import java.awt.GridBagConstraints;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.Insets;
import java.io.File;
import java.util.Hashtable;
import javax.swing.JLabel;
import javax.swing.JTextField;
import java.awt.Dimension;

import oracle.jdeveloper.model.JProject;
import oracle.ide.net.URLPath;
import oracle.ide.Ide;

public class PanelOne extends JPanel 
                   implements WizardValidateListener 
{
  Model model;
  
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  JLabel jLabel1 = new JLabel();
  JLabel jLabel2 = new JLabel();
  JLabel jLabel3 = new JLabel();
  JTextField projectName = new JTextField();
  JTextField projectRoot = new JTextField();
  JButton jButtonBrowse = new JButton();
  
  public PanelOne(Model m)
  {
    try
    {
      jbInit();
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }
    this.model = m;
  }
  private void jbInit() throws Exception
  {
    jLabel1.setText("Project name: ");
    jLabel1.setHorizontalTextPosition(SwingConstants.RIGHT);
    jLabel1.setHorizontalAlignment(SwingConstants.RIGHT);
    jLabel2.setText("Project root: ");
    jLabel2.setHorizontalTextPosition(SwingConstants.RIGHT);
    jLabel2.setHorizontalAlignment(SwingConstants.RIGHT);
    jLabel3.setText("Enhydra Application Wizard parameters");
    jLabel3.setFont(new Font("Dialog", 1, 14));
    jButtonBrowse.setText("Browse");
    jButtonBrowse.addActionListener(new java.awt.event.ActionListener() {
        public void actionPerformed(ActionEvent e) {
            jButtonBrowse_actionPerformed(e);
        }
    });
    this.setLayout(gridBagLayout1);
    this.add(jLabel1, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.2, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
    this.add(jLabel3, new GridBagConstraints(0, 0, 3, 1, 0.0, 0.5, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 16), 97, 16));
    this.add(projectName, new GridBagConstraints(1, 1, 2, 1, 0.0, 0.2, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
    this.add(jLabel2, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.5, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
    this.add(projectRoot, new GridBagConstraints(1, 2, 1, 1, 0.1, 0.5, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
    this.add(jButtonBrowse, new GridBagConstraints(2, 2, 1, 1, 0.0, 0.5, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));    
    
  }
  public void wizardValidatePage(WizardEvent p0)
  {
    if ((projectName.getText().equalsIgnoreCase("")) ||
        (projectRoot.getText().equalsIgnoreCase("")) )
    {
      JOptionPane.showMessageDialog(null,
                                    "Please fill both input fields",
                                    "Ooops",
                                    JOptionPane.ERROR_MESSAGE);
      Cancelable cancel = (Cancelable)p0;
      cancel.cancel();
    }
    model.setProjectName(this.projectName.getText());
    model.setProjectRoot(this.projectRoot.getText());
  }

  public void setDefaultValues()
  {
    this.projectName.setText(model.getProjectName());
    this.projectRoot.setText(model.getProjectRoot());
  }

    void jButtonBrowse_actionPerformed(ActionEvent e) {
        browseForDir();
    }

    private void browseForDir() {
        JFileChooser    chooser;
        chooser = new JFileChooser();
        chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        chooser.setCurrentDirectory(new File(model.getProjectRoot()));
        chooser.setDialogTitle("Choose Project Root Directory");
        chooser.setApproveButtonText("OK");
        int v = chooser.showOpenDialog(this);

        this.requestFocus();
        jButtonBrowse.requestFocus();
        if (v == JFileChooser.APPROVE_OPTION) {
            if (!(chooser.getCurrentDirectory() == null)) {
                model.setProjectRoot(chooser.getSelectedFile().toString());
                projectRoot.setText(model.getProjectRoot());
            }
        }
        chooser.removeAll();
        chooser = null;
    }
  
}
