package org.enhydra.kelp.jdev;

import java.awt.Dimension;
import java.awt.Image;

import java.io.*;

import java.net.URL;

import javax.swing.*;

import oracle.bali.ewt.wizard.ImageWizardPage;
import oracle.bali.ewt.wizard.Wizard;
import oracle.bali.ewt.wizard.WizardDialog;
import oracle.bali.ewt.wizard.WizardEvent;
import oracle.bali.ewt.wizard.WizardListener;

import oracle.ide.addin.Context;
import oracle.ide.model.NodeFactory;
import oracle.ide.model.Workspace;
import oracle.ide.net.URLPath;
import oracle.ide.util.GraphicsUtils;
import oracle.ide.wizard.WizardWelcomePage;

import oracle.ideimpl.explorer.ExplorerNode;
import oracle.ideimpl.navigator.NavigatorWindowImpl;

import oracle.jdeveloper.library.JDK;
import oracle.jdeveloper.library.JLibraryManager;
import oracle.jdeveloper.model.JProject;

import oracle.ide.Ide;
import oracle.jdeveloper.library.JProjectLibraryList;
import oracle.jdeveloper.library.JLibraryList;

import org.enhydra.kelp.jdev.codegen.wizard.JDevCodeGenWizard;
import org.enhydra.tool.ToolBoxInfo;
import java.util.LinkedList;
import oracle.jdeveloper.model.JProjectSettings;
import java.util.TreeMap;
import java.util.HashMap;
import oracle.jdeveloper.model.JProjectConfiguration;
import oracle.jdeveloper.runner.RunConfiguration;
import oracle.jdeveloper.compiler.ant.AntConfiguration;
import javax.swing.JOptionPane;

import org.enhydra.kelp.ant.node.AntProject;

public class RealWizard extends Wizard 
                        implements WizardListener
{
  private final static String WIZARD_LEFT_IMAGE = "/media/otterwizard.jpg";

  private Context context;
  private WizardDialog wDialog = null;

  private String enProjRoot = null;
  private String enProjName = null;
  
  ImageWizardPage[] wizardPage;
  
  WizardWelcomePage wwp;
  ImageWizardPage   iwpOne;
  
  private Model model;
  
  public RealWizard(Context ctx)
  {
    this.context = ctx;
    this.model = new Model();
    String wsPath = Ide.getActiveWorkspace().getURL().getFile();
    model.setProjectRoot(wsPath.substring(0, wsPath.lastIndexOf("/")));
    
    this.setPreferredSize(new Dimension(166, 387));

    wwp = createWelcomePage();
    this.addPage(wwp.getWizardPage());    
    
    iwpOne = createWizardPageOne(model);
    this.addPage(iwpOne);
    PanelOne panelOne = (PanelOne)iwpOne.getInteractiveArea();
    panelOne.setDefaultValues();
    iwpOne.addWizardValidateListener(panelOne); 

    if (!wwp.isHidden())
      this.setSelectedPage(wwp.getWizardPage());
    else
      this.setSelectedPage(iwpOne);

    this.setMustFinish(true);

    wizardPage = new ImageWizardPage[]
    {
      wwp.getWizardPage(),
      iwpOne,
    };
    // Create wizard Dialog
    wDialog = createWizardDialog();
    wDialog.setTitle("Create Enhydra Application");
    
    this.addWizardListener(this);
    wDialog.runDialog();
  }

  public void wizardApplyState(WizardEvent p0)
  {
  }
  public void wizardCanceled(WizardEvent p0)
  {
  }
  public void wizardFinished(WizardEvent p0)
  {
    JDevCodeGenWizard wizard = null;
    JProject enhydraProj = null;
    int canceled = 0;
    try 
    {
      wizard = new JDevCodeGenWizard(model.getProjectName(),
                                     model.getProjectRoot());
      wizard.getInnerPanel().initPreferredSize();
      canceled = wizard.showDialog(null);
    } catch (Exception ex) 
    {
      ex.printStackTrace();
    } 
    // create enhydra project now
    if (canceled != JOptionPane.CANCEL_OPTION) 
    {
      enhydraProj = createEnhydraProject();
      if (enhydraProj == null) {
        String msg = "Error creating Enhydra project";
        oracle.ide.Ide.getLogManager().getMsgPage().log(msg + "\n");
        JOptionPane.showMessageDialog(null,
                                      msg,
                                      "Ooops",
                                      JOptionPane.ERROR_MESSAGE);
        return;
      } 
      Workspace ws = Ide.getActiveWorkspace();
      ws.add(enhydraProj);

      ws.setActiveProject(enhydraProj);
      refreshNavigator(ws, enhydraProj);
    }
  }

  private JProject createEnhydraProject() 
  {
    setEnProjName(this.model.getProjectName());
    setEnProjRoot((this.model.getProjectRoot()).replace(File.separatorChar, '/'));
    JProject enhydraProj = null;
    String prjPath = enProjRoot + "/" + enProjName;
    AntProject antProject = null;
    try 
    {
      antProject = new AntProject(prjPath);
      enhydraProj = (JProject)NodeFactory.findOrCreate(JProject.class,
         new URL("file:///" + enProjRoot + "/" + enProjName + "/" + enProjName + ".jpr"));
      enhydraProj.setUsesDynamicPaths(true);
      URL[] enProjSrc = null;
      enProjSrc = new URL[] {new URL("file:///" + 
                      antProject.getProperty(AntProject.SRC_DIR)),
                  new URL("file:///" + 
                      antProject.getProperty(AntProject.XMLC_GENERETED_SRC_DIR)),
                  new URL("file:///" + 
                      antProject.getProperty(AntProject.DODS_GENERATED_SRC_DIR)),
                  new URL("file:///" + 
                      antProject.getProperty(AntProject.INPUT_DIR))};
      enhydraProj.setProjectSourcePath(new URLPath(enProjSrc));
      enhydraProj.setOutputDirectory(new URL("file:///" + 
        antProject.getProperty(AntProject.CLASSES_DIR)));
      enhydraProj.setHtmlRootDirectory(new URL("file:///" + 
        antProject.getProperty(AntProject.RESOURCES_DIR)));
      
    } catch (Exception ex) 
    {
      ex.printStackTrace();
    } 
      JDK jdk = setJDK1_4(enhydraProj);

      JProjectConfiguration enProjConfig = enhydraProj.getActiveConfiguration();
      String enhydraRoot = ToolBoxInfo.getEnhydraRoot();
      // set project's classpath
      String jdkBinDir = "";
      if (jdk != null)
        jdkBinDir = jdk.getSDKBinDir().getPath();
      URLPath enProjLibs = createAllLibs(enhydraRoot, jdkBinDir);
      enProjConfig.setAdditionalClassPath(enProjLibs);

      enProjConfig.setJdkName(
        (((JDK)(enhydraProj.getProjectLibraryList().getJdkList().get(0))).getName()) );          
      enProjConfig.setJdkVersionNumber(
        (((JDK)(enhydraProj.getProjectLibraryList().getJdkList().get(0))).getJavaVersion()) );

      // set ant config
      AntConfiguration antConfig = (AntConfiguration)enhydraProj.getProjectSettings().
          getCommonData().get("oracle.jdeveloper.compiler.ant.AntConfiguration");
      try 
      {
        antConfig.setProjectBuildfile(
            new URL("file:///" + enProjRoot + "/" + enProjName + "/build.xml"));
      } catch (Exception ex) 
      {
        ex.printStackTrace();
      } 
      antConfig.setMakeTarget("make");
      antConfig.setRebuildTarget("rebuild");

      setRunConfig(antProject, enProjConfig);

    return enhydraProj;
  }
  
  private void refreshNavigator(Workspace ws, JProject enhydraProj) 
  {
    NavigatorWindowImpl navWin = (NavigatorWindowImpl)
            Ide.getNavigatorManager().getSystemNavigator();
    navWin.show();
    ExplorerNode eNode = (ExplorerNode)navWin.getTreeExplorer().getRoot();
    eNode = (ExplorerNode)navWin.findTNode(ws, eNode);
    navWin.refresh(eNode);
    eNode = (ExplorerNode)navWin.findTNode(enhydraProj, eNode);
    navWin.expand(eNode, true);
    navWin.show();
  }

  private JDK setJDK1_4(JProject enhydraProj) 
  {
    JProjectLibraryList jProjLibList = new JProjectLibraryList();
    java.util.Iterator jdkIterator = JLibraryManager.getJDKs().iterator();
    JDK jdk = null;
    String version = null;
    boolean found1_4 = false;
    while ( jdkIterator.hasNext() && 
            !(found1_4) ) 
    {
      jdk = (JDK)jdkIterator.next();
      version = jdk.getJavaVersion().toString().substring(0,3);
      if (Float.parseFloat(version) >= Float.parseFloat("1.4")) 
      {
        LinkedList lList = new LinkedList();
        lList.add(jdk);
        jProjLibList.setJdkList(lList);
        jProjLibList.setOwner(null);
        jProjLibList.setLibraryList(null);
        found1_4 = true;
      }
    }
    if (found1_4) 
    {
      enhydraProj.setProjectLibraryList(jProjLibList);
    } else 
    {
      String msg = "Enhydra Applications need JDK 1.4 or higher to run.\nPlease install JDK 1.4 or higher.";
      JOptionPane.showMessageDialog(null,
                                    msg,
                                    "Ooops",
                                    JOptionPane.ERROR_MESSAGE);
        
    }   
    return jdk;
  }

  private URLPath createAllLibs(String enhydraRoot, String jdkBinDir)
  {
    URLPath enLibs = new URLPath();
    File file = new File(enhydraRoot + "/lib");
    enLibs.add(createEnhydraLibURLs(file));
    file = new File(enhydraRoot + "/dods/lib");
    enLibs.add(createEnhydraLibURLs(file));
    file = new File(enhydraRoot + "/lib/build");
    enLibs.add(createEnhydraLibURLs(file));
    file = new File(enhydraRoot + "/lib/tools/xalan");
    enLibs.add(createEnhydraLibURLs(file));
    try 
    {
      enLibs.add(new URL("jar:file:///" + enhydraRoot + "/build/anttask.jar!/"));
      if (!jdkBinDir.equals(""))
        enLibs.add(new URL("jar:file:///" + jdkBinDir + "../lib/tools.jar!/"));
    } catch (Exception ex) 
    {
      ex.printStackTrace();
    } 
    return enLibs;
  }

  private URLPath createEnhydraLibURLs(File file)  
  {
		// filter for dirs; jar and zip files
    URLPath dirLibs = new URLPath();
    ArchiveFilter archives = new ArchiveFilter();
		File[] fileList = null;
		if (file.isDirectory()) {
			fileList = file.listFiles(archives);
			for (int i = 0; i < fileList.length; i++) {
				File fileListElem = fileList[i];
				if (!fileListElem.isDirectory()) {
					try {
            dirLibs.add(new URL("jar:file:///" + fileListElem.getPath().replace('\\', '/') + "!/"));
					} catch (Exception e) {
						e.printStackTrace();
					}
				}
			}
		} else {
			System.err.println(file.getName() +" is not a directory.");
		}
    return dirLibs;
	}

  private void setRunConfig(AntProject antProject, JProjectConfiguration enProjConfig)
  {
    // set project's run configuration
    RunConfiguration enRunConfig = 
      (RunConfiguration)enProjConfig.getConfigData().get(
          "oracle.jdeveloper.runner.RunConfiguration");
    enRunConfig.setRunActiveFile(false);
    String enhydraRoot = ToolBoxInfo.getEnhydraRoot();
    File file = new File(enhydraRoot);
    try 
    {
      URL multiserver = new URL("jar:file:///" + file.getPath() + 
          "/lib/enhydra.jar!/com/lutris/multiServer/MultiServer.class");
      enRunConfig.setTargetURL(multiserver);
      enRunConfig.setRunDirectoryURL(new URL("file:///" + 
                                              antProject.getProperty(AntProject.OUTPUT_DIR)));
    } catch (Exception ex) 
    {
      ex.printStackTrace();
    } 
    enRunConfig.setProgramArguments(
                                    antProject.getProperty(AntProject.OUTPUT_DIR) +
                                    "/conf/multiserver.conf");
    enRunConfig.setClearLogBeforeRun(true);
    enRunConfig.setJavaOptions("-Denhydra.home=\"" + enhydraRoot + "\"");
  }
  public void wizardSelectionChanged(WizardEvent wEvent)
  {
    
    int pageNo = 0;
    try { pageNo = wEvent.getPage().getIndex(); }
    catch (Exception ignore) { } 
    
    if (pageNo == 0) // to Welcome
      ;
    else if (pageNo == 1) 
    {
      PanelOne p1 = (PanelOne)iwpOne.getInteractiveArea();
      p1.setDefaultValues();
    }
  }

  private WizardWelcomePage createWelcomePage()
  {
    // This key is used to remember the "Show next time" check box!
    final String strShowAgainKey = "APP_WIZARD";
    WizardWelcomePage wp = new WizardWelcomePage(strShowAgainKey);
    // Set the image
    java.awt.Image img = GraphicsUtils.loadFromResource(WIZARD_LEFT_IMAGE, this.getClass());
    
    if (img != null)
      wp.setImage(img);
    else
      System.out.println(WIZARD_LEFT_IMAGE + " not found");
    // Set the Title
    final String welcomeTitle =  "Creating Enhydra Application";
    wp.setTitle(welcomeTitle);
    // Set the Description Text for first page
    final String welcomeDesc = "\n\n" +
      "This wizard will help you to create Enhydra application.\n" +
      "Please, enter project name and path to the project root folder.\n" +
      "A new folder with the name of the project will be created\n" +
      "under the root.\n" +
      "\n\n" +
      "Press Next to continue\n";
    wp.setDescription(welcomeDesc);
    // Return results    
    return wp;
  }
  
  private ImageWizardPage createWizardPageOne(Model m)
  {
    PanelOne panel = new PanelOne(m);
    final String title = "Input parameters";
    Image img = GraphicsUtils.createImageIcon(GraphicsUtils.loadFromResource(WIZARD_LEFT_IMAGE, this.getClass())).getImage();
    ImageWizardPage iwp = new ImageWizardPage(panel, img, title);
    return iwp; 
  }
  
  private WizardDialog createWizardDialog()
  {
    WizardDialog wdlg = new WizardDialog(this, Ide.getMainWindow());
    return wdlg;
  }

  public void setEnProjRoot(String root)
  {
    enProjRoot = root;
  }

  public String getEnProjRoot()
  {
    return enProjRoot;
  }

  public void setEnProjName(String root)
  {
    enProjName = root;
  }

  public String getEnProjName()
  {
    return enProjName;
  }
  
}
