
/*
 * Enhydra Java Application Server Project
 *
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific terms governing rights and limitations
 * under the License.
 *
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 *
 * Contributor(s):
 * Paul Mahar
 *
 */
package org.enhydra.tool.codegen.internal;

// ToolBox imports
import org.enhydra.tool.ToolBoxInfo;
import org.enhydra.tool.codegen.ProjectOptionSet;
import org.enhydra.tool.codegen.GeneratorException;
import org.enhydra.tool.codegen.GeneratorOption;
import org.enhydra.tool.codegen.Constants;

// Standard imports
import java.io.File;
import java.util.StringTokenizer;
import java.util.ResourceBundle;

/**
 * This class instantiates a set of default GeneratorOptions during
 * initialization. The default options include: project, d, package
 * copywrite, copywritefile, make, script, j2ee and overwrite.
 */
public class AppOptionSet extends ProjectOptionSet implements Constants {

    /**
     * Property client option.
     */
    public static final String CLIENT = "client";    // nores

    public AppOptionSet() {
        super();
        String[]     docTypes = new String[0];
        StringBuffer clientBuf = new StringBuffer();
        boolean      e4 = false;

        e4 = (!ToolBoxInfo.isEnhydra3());
        docTypes = ToolBoxInfo.getSupportedDocTypes();
        clientBuf.append(res.getString("Application_client"));
        clientBuf.append(' ');
        for (int i = 0; i < docTypes.length; i++) {
            if (i > 0) {
                clientBuf.append(',');
                clientBuf.append(' ');
            }
            clientBuf.append(docTypes[i].toUpperCase());
        }
        try {
            add(new GeneratorOption(CLIENT, TYPE_HTML.toUpperCase(),
                                    res.getString("CLIENT"),
                                    clientBuf.toString(), false, true));
        } catch (GeneratorException e) {
            e.printStackTrace();
        }
    }

}
