
/*
 * Enhydra Java Application Server Project
 *
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific terms governing rights and limitations
 * under the License.
 *
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 *
 * Contributor(s):
 * Paul Mahar
 *
 */
package org.enhydra.tool.codegen.internal;
//
import org.enhydra.tool.codegen.Constants;
import org.enhydra.tool.codegen.ProjectReplacementSet;
import org.enhydra.tool.common.ReplacementSet;
import org.enhydra.tool.common.Replacement;
import org.enhydra.tool.common.ToolException;
//

/**
 * This class instantiates a set of default Replacements during
 * initialization.
 */
public class AppReplacementSet extends ProjectReplacementSet implements Constants {


    /**
     * Replacement key for the client type
     */
    public static final String CLIENT = "@CLIENT@";                // nores
    /**
     * Replacement key for the content type
     */
    public static final String CONTENT_TYPE = "@CONTENT_TYPE@";    // nores
    /**
     * Replacement key for the application class (proper case)
     */
    public static final String APP = "at_APP_at";    // nores


    /**
     * Create a default set of replacement operations. This is a convenience
     * class that can be used as the basis for building custom replacement
     * set within a generator.
     */
    public AppReplacementSet() {
    	super();
        try {
            this.add(new Replacement(AppReplacementSet.CLIENT,
                                     TYPE_HTML.toUpperCase()));
            this.add(new Replacement(AppReplacementSet.CONTENT_TYPE,
                                     CONTENT_HTML));
            this.add(new Replacement(AppReplacementSet.APP,
                                     APP));

        } catch (ToolException e) {
            e.printStackTrace();
        }
    }

}
